Integrate cmdlineopts.clp into grml-debootstrap
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8
9 # error_handler {{{
10 [ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
11 [ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
12
13 error_handler() {
14    last_exit_code="$?"
15    last_bash_command="$BASH_COMMAND"
16    if [ "$REPORT_TRAP_ERR" = "yes" ]; then
17       echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
18 last bash command: $last_bash_command"
19    fi
20    if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
21       return
22    fi
23    ## Check if "bailout" function is available.
24    ## This is not the case in chroot-script.
25    if command -v bailout >/dev/null 2>&1; then
26       bailout 1
27    else
28       echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
29       exit 1
30    fi
31 }
32
33 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
34    set -E
35    set -o pipefail
36    trap "error_handler" ERR
37    export -f "error_handler"
38 fi
39 # }}}
40
41 # variables {{{
42 PN="$(basename "$0")"
43 if [[ -d "$(dirname "$(which "$0")")"/.git ]]; then
44   VERSION="$(git describe | sed 's|^v||')"
45 else
46   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
47 fi
48 VERSION="${VERSION:-unknown}"
49 MNTPOINT="/mnt/debootstrap.$$"
50
51 # defaults
52 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
53 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
54 [ -n "$DEBCONF" ] || DEBCONF='yes'
55 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
56 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
57 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
58 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
59 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
60 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
61 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://httpredir.debian.org/debian'
62 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
63 [ -n "$FORCE" ] || FORCE=''
64 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
65 [ -n "$INITRD" ] || INITRD='yes'
66 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
67 [ -n "$LOCALES" ] || LOCALES='yes'
68 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
69 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
70 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
71 [ -n "$PACKAGES" ] || PACKAGES='yes'
72 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
73 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
74 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
75 [ -n "$RELEASE" ] || RELEASE='stretch'
76 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
77 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
78 [ -n "$SECURE" ] || SECURE='yes'
79 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
80 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
81 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
82 [ -n "$VMSIZE" ] || VMSIZE="2G"
83
84 # inside the chroot system locales might not be available, so use minimum:
85 export LANG=C
86 export LC_ALL=C
87 export LANGUAGE=C
88
89 # make sure interactive mode is only executed when
90 # using an empty configuration file or option --interactive
91 INTERACTIVE=''
92 # }}}
93
94 # help text {{{
95 usage() {
96   echo "$PN - wrapper around debootstrap for installing Debian
97
98 Usage: $PN [options]
99
100 Bootstrap options:
101
102   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
103   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
104                          instead of fetching packages from a mirror.
105   -r, --release <name>   Release of new Debian system (default: stretch).
106   -t, --target <target>  Target partition (/dev/...) or directory where the
107                          system should be installed to.
108   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
109                          has no effect if -t is given and represents a directory.
110       --debopt <params>  Extra parameters passed to the debootstrap command.
111       --interactive      Use interactive mode (frontend).
112       --nodebootstrap    Skip debootstrap, only do configuration to the target.
113       --grub <device>    Target for grub installation. Usage example: /dev/sda
114       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
115       --arch <arch>      Set target architecture, use for installing i386 on amd64.
116       --filesystem <fs>  Filesystem that should be used when target is a partition
117                          or Virtual Machine (see --vmfile).
118       --force            Do not prompt for user acknowledgement.
119
120 Options for Virtual Machine deployment:
121
122       --vm               Set up a Virtual Machine on an existing block device
123                          instead of plainly installing to a partition or
124                          directory. Needs to be combined with --target.
125                          Example: --vm --target /dev/mapper/your-vm-disk
126       --vmfile           Like --vm, but install into a regular file (created by
127                          'qemu-img create -f raw ...') instead.
128                          Example: --vmfile --target /mnt/sda1/qemu.img
129       --vmsize <size>    Use specified size for size of VM file (default: 2G).
130                          Syntax as supported by qemu-img, like: --vmsize 3G
131
132 Configuration options:
133
134   -c, --config <file>      Use specified configuration file, defaults to
135                              /etc/debootstrap/config
136   -d, --confdir <path>     Place of config files for debootstrap, defaults
137                              to /etc/debootstrap
138       --packages <file>    Install packages defined in specified list file
139                              instead of using /etc/debootstrap/packages.
140       --nopackages         Skip installation of packages defined in
141                              /etc/debootstrap/packages
142       --nokernel           Skip installation of default kernel images.
143       --nointerfaces       Do not copy /etc/network/interfaces from host system
144                            to target system.
145                            (This option is automatically enabled when using --vmfile.)
146       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
147                            DHCP for eth0) instead of taking over config from host system.
148       --debconf <file>     Pre-seed packages using specified pre-seed db file.
149       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
150       --backportrepos      Enable Debian's backports repository (backports.debian.org).
151       --keep_src_list      Do not overwrite user provided apt sources.list.
152       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
153       --non-free           Enable non-free in COMPONENTS (defaults to 'main' only).
154       --hostname <name>    Hostname of Debian system.
155       --nopassword         Do not prompt for the root password.
156       --password <pwd>     Use specified password as password for user root.
157       --bootappend <line>  Add specified appendline to kernel whilst booting.
158       --chroot-scripts <d> Execute chroot scripts from specified directory.
159       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
160       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
161       --remove-configs     Delete grml-debootstrap configuration files from installed system.
162
163 Other options:
164
165   -v, --verbose            Increase verbosity.
166       --debug              Execute in very verbose way.
167   -h, --help               Print this usage information and exit.
168   -V, --version            Show summary of options and exit.
169
170 Usage examples can be found in the grml-debootstrap manpage.
171 Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
172 "
173 }
174
175 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
176    usage
177    echo 'Please notice that this script requires root permissions!'
178    exit 0
179 fi
180 # }}}
181
182 # early helper functions {{{
183 GOOD='\e[32;01m'
184 BAD='\e[31;01m'
185 WARN='\e[33;01m'
186 NORMAL='\e[0m'
187
188 einfo() {
189   einfon "$1\n"
190   return 0
191 }
192
193 einfon() {
194   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
195   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
196   LAST_E_CMD=einfon
197   return 0
198 }
199
200 ewarn() {
201   printf " %s*%s $*\n" "${WARN}" "${NORMAL}"
202   return 0
203 }
204
205 eerror() {
206   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
207   printf " %s*%s $*\n" "${BAD}" "${NORMAL}" >&2
208   LAST_E_CMD=eerror
209   return 0
210 }
211
212 eend() {
213   local retval="${1:-0}"
214   shift
215   if [ "$retval" -gt 0 ]; then
216     printf " %s-> Failed (rc=%s)%s\n" "${BAD}" "${retval}" "${NORMAL}"
217   fi
218   return "$retval"
219 }
220
221 check4root(){
222   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
223     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
224   fi
225 }
226
227 check4progs(){
228   local RC=''
229   for arg in "$@" ; do
230     which "$arg" >/dev/null 2>&1 || RC="$arg"
231   done
232   if [ -n "$RC" ] ; then
233      echo "$RC not installed"
234      return 1
235   fi
236 }
237 # }}}
238
239 # helper functions {{{
240 cleanup() {
241   if [ -n "$CHROOT_VARIABLES" ] ; then
242     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
243   fi
244
245   if [ -n "$STAGES" ] ; then
246     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
247   fi
248
249   # Remove temporary mountpoint again
250   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
251     rmdir "$MNTPOINT" 2>/dev/null
252   fi
253
254   # make sure $TARGET is not mounted when exiting grml-debootstrap
255   if [ -n "$MNTPOINT" ] ; then
256     if grep -q "$MNTPOINT" /proc/mounts ; then
257       # make sure nothing is left inside chroot so we can unmount it
258       for service in ssh mdadm ; do
259         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
260           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
261         fi
262       done
263
264       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
265
266       # ugly, but make sure we really don't leave anything (/proc /proc and
267       # /dev /dev are intended, trying to work around timing issues, see #657023)
268       for ARG in /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
269         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
270         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
271       done
272
273       if [ -n "$ISODIR" ] ; then
274         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
275       fi
276
277       if [ -n "$DIRECTORY" ] ; then
278         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
279       else
280         einfo "Unmounting $MNTPOINT"
281         umount "$MNTPOINT"
282         eend $?
283       fi
284
285       if [ -n "$STAGES" ] ; then
286         echo -n "Removing stages directory ${STAGES}: "
287         rm -rf "$STAGES" && echo 'done'
288       fi
289
290       # remove directory only if we used the default with process id inside the name
291       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
292         einfo "Removing directory ${MNTPOINT}"
293         rmdir "$MNTPOINT"
294         eend $?
295       fi
296     fi
297   fi
298
299   if [ -n "${ORIG_TARGET}" ] ; then
300     einfo "Removing loopback mount of file ${ORIG_TARGET}."
301     kpartx -d "${ORIG_TARGET}" ; eend $?
302   fi
303 }
304
305 # we want to exit smoothly and clean:
306 bailout(){
307
308   cleanup
309
310   [ -n "$1" ] && EXIT="$1" || EXIT="1"
311   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
312
313   exit "$EXIT"
314 }
315 trap bailout HUP INT QUIT TERM
316
317 # we want to execute all the functions only once, simple check for it:
318 stage() {
319   if [ -n "$2" ] ; then
320      echo "$2" > "${STAGES}/${1}"
321      return 0
322   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
323      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
324      ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
325      return 1
326   fi
327 }
328 # }}}
329
330 # make sure we have what we need {{{
331 check4progs debootstrap || bailout 1
332 # }}}
333
334 # source main configuration file {{{
335 if [ -r /etc/debootstrap/config ] ; then
336   # shellcheck disable=SC1091
337   . /etc/debootstrap/config
338 fi
339 # }}}
340
341 # cmdline handling {{{
342 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs
343
344 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
345   $CMDLINE_OPTS -- "$@")
346
347 if [ $? != 0 ]; then
348   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
349 fi
350 eval set -- "$_opt_temp"
351
352 while :; do
353   case "$1" in
354
355   # == Bootstrap options
356   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
357     shift; _opt_mirror="$1"
358     ;;
359   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
360     shift; _opt_iso="$1"
361     ;;
362   --release|-r)        # Release of new Debian system
363     shift; _opt_release="$1"
364     ;;
365   --target|-t)         # Target partition (/dev/...) or directory
366     shift; _opt_target="$1"
367     ;;
368   --vm)                # Virtual machine image (no file)
369     _opt_vm="T"
370     ;;
371   --vmfile)            # Virtual machine file
372     _opt_vmfile="T"
373     ;;
374   --vmsize)            # size of Virtual machine file
375     shift; _opt_vmsize="$1"
376     ;;
377   --mntpoint|-p)       # Mountpoint used for mounting the target system
378     shift; _opt_mntpoint="$1"
379     ;;
380   --debopt)            # Extra parameters passed to the debootstrap command
381     shift; _opt_debopt="$1"
382     ;;
383   --filesystem)        # Filesystem that should be used
384     shift; _opt_filesystem="$1"
385     ;;
386   --interactive)       # Use interactive mode (frontend)
387     _opt_interactive=T
388     ;;
389   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
390     _opt_nodebootstrap=T
391     ;;
392   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
393     _opt_nopackages=T
394     ;;
395   --arch)              # Target architecutre
396     shift; _opt_arch="$1"
397     ;;
398   # just for backwards compatibility
399   --insecure)
400     _opt_insecure=T
401     ;;
402   #
403
404   # == Configuration options
405   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
406     shift; _opt_config="$1"
407     ;;
408   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
409     shift; _opt_confdir="$1"
410     ;;
411   --packages)          # Install packages defined in specified file
412     shift; _opt_packages="$1"
413     _opt_packages_set=T
414     ;;
415   --debconf)           # Pre-seed packages using specified file
416     shift; _opt_debconf="$1"
417     _opt_debconf_set=T
418     ;;
419   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
420     shift; _opt_pre_scripts="$1"
421     _opt_pre_scripts_set=T
422     ;;
423   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
424     shift; _opt_scripts="$1"
425     _opt_scripts_set=T
426     ;;
427   --post-scripts)       # Execute scripts from specified directory
428     shift; _opt_post_scripts="$1"
429     _opt_post_scripts_set=T
430     ;;
431   --chroot-scripts)   # Execute chroot scripts from specified directory
432     shift; _opt_chroot_scripts="$1"
433     _opt_chroot_scripts_set=T
434     ;;
435   --keep_src_list)     # Do not overwrite user provided apt sources.list
436     _opt_keep_src_list=T
437     ;;
438   --hostname)          # Hostname of Debian system
439     shift; _opt_hostname="$1"
440     ;;
441   --password)          # Use specified password as password for user root
442     shift; _opt_password="$1"
443     ;;
444   --defaultinterfaces) # Install default /etc/network/interfaces
445     _opt_defaultinterfaces=T
446     ;;
447   --nointerfaces)      # Skip installation of /etc/network/interfaces
448     _opt_nointerfaces=T
449     ;;
450   --nokernel)          # Skip installation of default kernel images
451     _opt_nokernel=T
452     ;;
453   --nopassword)        # Skip password dialog
454     _opt_nopassword=T
455     ;;
456   --grmlrepos)         # Enable Grml repository
457     _opt_grmlrepos=T
458     ;;
459   --backportrepos)     # Enable Debian backports repository
460     _opt_backportrepos=T
461     ;;
462   --bootappend)        # Add specified appendline to kernel whilst booting
463     shift; _opt_bootappend="$1"
464     ;;
465   --grub)              # Target for grub installation. Use grub syntax for specifying
466     shift; _opt_grub="$1"
467     ;;
468   --efi)               # Target for EFI boot installation
469     shift; _opt_efi="$1"
470     ;;
471   --contrib)           # Add 'contrib' to list of components
472     _opt_contrib=T
473     ;;
474   --non-free)          # Add 'non-free' to list of components
475     _opt_non_free=T
476     ;;
477   --remove-configs)    # Drop config files from installed system
478     _opt_remove_configs=T
479     ;;
480
481   # == Other options
482   --verbose|-v)        # Increase verbosity
483     if [ "$_opt_verbose" ]; then _opt_verbose=`expr $_opt_verbose + 1`
484     else _opt_verbose=1; fi
485     ;;
486   --debug)             # Execute in debug mode
487     _opt_debug=T
488     ;;
489   --help|-h)           # Print usage information and exit
490     _opt_help=T
491     ;;
492   --version|-V)        # Show version information and exit
493     _opt_version=T
494     ;;
495   --force)             # Do not prompt for user input
496     _opt_force=T
497     ;;
498   --)
499     shift; break
500     ;;
501   *)
502     eerror "Internal getopt error!"; eend 1 ; exit 1
503     ;;
504   esac
505   shift
506 done
507
508 # == business-logic of command line parameter-processing
509
510 # source configuration file in <confdir> if supplied. {{{
511 [ "$_opt_confdir" ] && {
512   CONFFILES=$_opt_confdir
513   einfo "Using config files under $CONFFILES/."
514   if ! [ -r "$CONFFILES/config" ] ; then
515     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
516   fi
517   # shellcheck disable=SC1091 source=config
518   if ! . "$CONFFILES/config" ; then
519     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
520   fi
521   # restore the command line parameter value
522   CONFFILES=$_opt_confdir
523 }
524 # }}}
525
526 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
527 [ "$_opt_iso" ]                 && ISO=$_opt_iso
528 [ "$_opt_release" ]             && RELEASE=$_opt_release
529 [ "$_opt_target" ]              && TARGET=$_opt_target
530 [ "$_opt_vm" ]                  && VIRTUAL=1
531 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
532 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
533 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
534 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
535 [ "$_opt_interactive" ]         && INTERACTIVE=1
536 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
537 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
538 [ "$_opt_packages_set" ]        && PACKAGES='yes'
539 [ "$_opt_nopackages" ]          && PACKAGES=''
540 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
541 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
542 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
543 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
544 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
545 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
546 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
547 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
548 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
549 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
550 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
551 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
552 [ "$_opt_nokernel" ]            && NOKERNEL="true"
553 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
554 [ "$_opt_grub" ]                && GRUB=$_opt_grub
555 [ "$_opt_efi" ]                 && EFI=$_opt_efi
556 [ "$_opt_arch" ]                && ARCH=$_opt_arch
557 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
558 [ "$_opt_force" ]               && FORCE=$_opt_force
559 [ "$_opt_verbose" ]             && VERBOSE="-v"
560 [ "$_opt_debug" ]               && DEBUG="true"
561 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
562
563 # make sure main is always included
564 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
565 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
566 [ "$_opt_non_free" ]            && COMPONENTS="$COMPONENTS non-free"
567
568 # command line option checks
569 if [ "$_opt_scripts_set" ] ; then
570   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
571   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
572 fi
573
574 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
575   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
576   eerror "The --grub option is unneeded as GRUB will be installed automatically."
577   eend 1
578   bailout 1
579 fi
580
581
582 if [ "$DEBUG" = "true" ] ; then
583   set -x
584 fi
585
586 [ "$_opt_help" ] && {
587   usage ; eend 0
588   eend 0
589   exit 0
590 }
591
592 [ "$_opt_version" ] && {
593   einfo "$PN - version $VERSION"
594   einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
595   eend 0
596   exit 0
597 }
598 # }}}
599
600 # check for root permissions {{{
601 if ! check4root ; then
602    echo "For usage instructions please execute '$PN --help'."
603    bailout 1
604 fi
605 # }}}
606
607 # make sure we have what we need {{{
608 if [ -n "$VIRTUAL" ] ; then
609   check4progs kpartx parted qemu-img || bailout 1
610 fi
611 # }}}
612
613 # source specified configuration file {{{
614 if [ -n "$CONFIGFILE" ] ; then
615   einfo "Reading specified config file $CONFIGFILE."
616   # shellcheck disable=SC1091 source=config
617   if ! . "$CONFIGFILE" ; then
618     eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
619   fi
620 fi
621 # }}}
622
623 # backwards compatibility checks {{{
624 if [ -n "$GROOT" ] ; then
625    eerror "Error: you seem to have \$GROOT configured."
626    eerror "This variable is no longer supported, please visit the"
627    eerror "grml-debootstrap documentation for details."
628    eend 1
629    bailout 1
630 fi
631
632 if echo "$GRUB" | grep -q '^hd' ; then
633    eerror "Error: this syntax for the grub configuration variable is no longer supported."
634    eerror "Please do not use hd... any longer but /dev/sdX instead."
635    eend 1
636    bailout 1
637 fi
638 # }}}
639
640 # welcome screen {{{
641 welcome_dialog()
642 {
643    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
644 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
645 }
646 # }}}
647
648 # ask for target {{{
649 prompt_for_target()
650 {
651   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
652                sed 's/*//' | \
653                grep -v 'Extended$' | \
654                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
655
656   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
657      dialog --title "$PN" --trim \
658      --msgbox "Sorry, no partitions found. Please configure your
659      harddisks (see /proc/partitions) using a tool like fdisk,
660      cfdisk, gpart, gparted,..." 0 0
661      bailout 1
662   fi
663
664   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
665                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
666                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
667                      echo "$i" "$fs"
668                      unset fs
669                    done)
670
671   # shellcheck disable=SC2086
672   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
673          --menu "Please select the target partition:" 0 0 0 \
674          $PARTITION_LIST)
675   [ $? -eq 0 ] || bailout 1
676 }
677 # }}}
678
679 # ask for bootmanager {{{
680 prompt_for_bootmanager()
681 {
682   ADDITIONAL_PARAMS=""
683
684   if echo "$TARGET" | grep -q "/dev/md" ; then
685      MBRPART="all disks of Software RAID $TARGET"
686   else
687      # figure out whole disk device
688      found=
689      for device in /dev/disk/by-id/*
690      do
691         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
692         found=1
693         break
694      done
695      # shellcheck disable=SC2001
696      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
697      if [ -e "$MBRDISK" ]; then
698         MBRDISK=$(readlink -f "$MBRDISK")
699      else
700         # fall back to old behaviour
701         # shellcheck disable=SC2001
702         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
703      fi
704
705      MBRPART="MBR of $MBRDISK"
706   fi
707
708   for device in cciss/c0d0 sda hda; do
709     if [ "/dev/$device" != "${MBRDISK}" ]; then
710       grep -q $device /proc/partitions && \
711       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
712     fi
713   done
714   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
715
716   OIFS="$IFS"; IFS=:
717
718   # shellcheck disable=SC2086
719   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
720           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
721             mbr       "install bootmanager into $MBRPART" \
722             nowhere   "do not install bootmanager at all" \
723           ${ADDITIONAL_PARAMS})
724   [ $? -eq 0 ] || bailout 3
725   IFS="$OIFS"
726
727   case "$GETMBR" in
728     mbr)
729       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
730       if echo "$TARGET" | grep -q "/dev/md" ; then
731         GRUB="$TARGET"
732       else
733         GRUB="$MBRDISK"
734       fi
735       ;;
736     hda)
737       GRUB="/dev/hda"
738       ;;
739     sda)
740       GRUB="/dev/sda"
741       ;;
742     nowhere)
743       GRUB=''
744       ;;
745   esac
746 }
747 # }}}
748
749 # ask for Debian release {{{
750 prompt_for_release()
751 {
752   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='stretch'
753   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
754             "Please enter the Debian release you would like to use for installation:" \
755             0 50 5 \
756             lenny    Debian/5.0 \
757             squeeze  Debian/6.0 \
758             wheezy   Debian/7.0 \
759             jessie   Debian/8.0 \
760             stretch  Debian/9.0 \
761             sid      Debian/unstable)"
762   [ $? -eq 0 ] || bailout
763 }
764 # }}}
765
766 # ask for hostname {{{
767 prompt_for_hostname()
768 {
769   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
770             "Please enter the hostname you would like to use for installation:" \
771             0 0 "$HOSTNAME")"
772   [ $? -eq 0 ] || bailout
773 }
774 # }}}
775
776 # ask for password {{{
777 prompt_for_password()
778 {
779   if [ "$_opt_nopassword" ] ; then
780     einfo "Skip asking for root password as requested."
781     return 0
782   fi
783
784   ROOTPW1='PW1'
785   ROOTPW2='PW2'
786   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
787     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
788     "Please enter the password for the root account:" 10 60)
789     [ $? -eq 0 ] || bailout
790
791     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
792     "Please enter the password for the root account again for \
793     confirmation:" 10 60)
794     [ $? -eq 0 ] || bailout
795
796     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
797       dialog --stdout --title "${PN}" --ok-label \
798         "Retry" --msgbox "Passwords do not match!" 10 60
799     fi
800   done
801   ROOTPASSWORD="$ROOTPW1"
802 }
803 # }}}
804
805 # ask for Debian mirror {{{
806 prompt_for_mirror()
807 {
808   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
809
810   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
811           --menu "Where do you want to install from?" 0 0 0 \
812             net   "install via network (downloading from mirror)" \
813             local "install from local directory/mirror"
814           )
815   [ $? -eq 0 ] || bailout
816
817   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
818      [ -n "$MIRROR" ] || MIRROR='http://httpredir.debian.org/debian'
819      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
820                "Please enter Debian mirror you would like to use for installing packages." \
821                0 0 $MIRROR)"
822      [ $? -eq 0 ] || bailout
823   else # CHOOSE_MIRROR == local
824      [ -n "$ISO" ] || ISO='/mnt/mirror'
825      ISO="$(dialog --stdout --title "${PN}" --inputbox \
826                "Please enter directory name you would like to use for installing packages." \
827                0 0 $ISO)"
828      [ $? -eq 0 ] || bailout
829   fi
830 }
831 # }}}
832
833 # software raid setup {{{
834 config_swraid_setup()
835 {
836 TMPFILE=$(mktemp)
837
838 # Currently we support only raid1:
839 RAIDLEVEL='raid1'
840
841 MD_LIST=$(for i in $(seq 0 9) ; do
842             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
843             echo "/dev/md$i /dev/md$i"
844           done)
845
846 # shellcheck disable=SC2086
847 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
848 --menu "Which device do you want to use for ${RAIDLEVEL}?
849
850 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
851 $MD_LIST)
852 [ $? -eq 0 ] || bailout 20
853
854 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
855              sed 's/*//' | \
856              grep -v 'Extended$' | \
857              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
858 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
859 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
860                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
861                  done)
862
863 # shellcheck disable=SC2086
864 dialog --title "$PN" --separate-output \
865        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
866        $PARTITION_LIST 2>"$TMPFILE"
867 [ $? -eq 0 ] || bailout
868 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
869
870 NUM_PARTITIONS=0
871 while IFS= read -r i; do
872   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
873 done < "$TMPFILE"
874
875 # force metadata version 0.90 for lenny so old grub can boot from this array.
876 METADATA_VERSION=""
877 if [ "$RELEASE" = "lenny" ]; then
878    METADATA_VERSION="-e0"
879 fi
880
881 ERRORFILE=$(mktemp)
882 # shellcheck disable=SC2086
883 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
884       --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
885 RC=$?
886 if [ "$RC" = 0 ] ; then
887    dialog --title "$PN" --msgbox \
888    "Creating $TARGET was successful." 0 0
889    rm -f "$TMPFILE" "$ERRORFILE"
890 else
891    dialog --title "$PN" --msgbox \
892    "There was an error setting up $TARGET:
893
894 $(cat "$ERRORFILE")
895
896 Exiting." 0 0
897    rm -f "$TMPFILE" "$ERRORFILE"
898    bailout 1
899 fi
900
901 }
902
903 prompt_for_swraid()
904 {
905 if dialog --stdout --title "$PN" \
906           --defaultno --yesno "Do you want to configure Software RAID?
907
908 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
909   config_swraid_setup
910 fi
911 }
912 # }}}
913
914 # user should recheck his configuration {{{
915 # support full automatic installation:
916 checkforrun() {
917    dialog --timeout 10 --title "$PN" \
918           --yesno "Do you want to stop at this stage?
919
920 Notice: you are running ${PN} in non-interactive mode.
921 ${PN} will install Debian ${RELEASE} on ${TARGET}.
922 Last chance to quit. Timeout of 10 seconds running....
923
924 Do you want to stop now?" 0 0 2>/dev/null
925 }
926 # }}}
927
928 format_efi_partition() {
929   if [ -z "$EFI" ] ; then
930     return 0
931   fi
932
933   if ! [ -b "$EFI" ] ; then
934     eerror "Specified efi argument [$EFI] not a valid block device."
935     bailout 1
936   fi
937
938   if fsck.vfat -bn "$EFI" >/dev/null; then
939     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying." ; eend 0
940   else
941     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
942     mkfs.fat -F32 -n "EFI System Partition" "$EFI"
943     RC=$?
944     if [ $RC -eq 0 ] ; then
945       eend 0
946     else
947       eerror "Error while creating filesystem on ${EFI}."
948       eend 1
949       bailout 1
950     fi
951   fi
952 }
953
954 # check for EFI support or try to enable it {{{
955 efi_support() {
956   if lsmod | grep -q efivars ; then
957     einfo "EFI support detected." ; eend 0
958     return 0
959   fi
960
961   if modprobe efivars &>/dev/null ; then
962     einfo "EFI support enabled now." ; eend 0
963     return 0
964   fi
965
966   return 1
967 }
968 # }}}
969
970 # make sure the user is aware of the used configuration {{{
971 checkconfiguration()
972 {
973
974 if efi_support ; then
975   if [ -z "$_opt_efi" ] ; then
976     ewarn "EFI support detected but no --efi option given, please consider enabling it." ; eend 0
977   fi
978 else
979   if [ -n "$_opt_efi" ] ; then
980      eerror "EFI option used but no EFI support detected." ; eend 0
981      bailout 1
982   fi
983 fi
984
985 if [ -n "$AUTOINSTALL" ] ; then
986    if checkforrun ; then
987       eerror "Exiting as requested" ; eend 0
988       bailout 1
989    fi
990 elif [ -n "$INTERACTIVE" ] ; then
991
992    INFOTEXT="Please recheck configuration before execution:
993    "
994    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
995    Target:          $TARGET"
996    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
997    Install grub:    $GRUB"
998    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
999    Install efi:     $EFI"
1000    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1001    Using release:   $RELEASE"
1002    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1003    Using hostname:  $HOSTNAME"
1004    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1005    Using mirror:    $MIRROR"
1006    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1007    Using ISO:       $ISO"
1008    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1009    Using arch:      $ARCH"
1010    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1011    Config files:    $CONFFILES"
1012
1013    INFOTEXT="$INFOTEXT
1014
1015 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1016
1017    dialog --title "$PN" --no-collapse \
1018           --yesno "$INFOTEXT" 0 0
1019    [ $? -eq 0 ] || bailout 0
1020
1021 else # if not running automatic installation display configuration and prompt for execution:
1022    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1023    echo
1024    echo "   Target:          $TARGET"
1025
1026    # do not display if MNTPOINT is the default one
1027    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1028
1029    if [ -n "$VIRTUAL" ] ; then
1030       echo "   Install grub:    yes"
1031    else
1032      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1033      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1034    fi
1035
1036    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1037    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1038    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1039    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1040    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1041    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1042    if [ -n "$VIRTUAL" ] ; then
1043       echo "   Deploying as Virtual Machine."
1044       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1045          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1046       fi
1047    fi
1048
1049    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1050       echo
1051       echo "   You do not have a TTY allocated, your password will be shown in"
1052       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1053    fi
1054
1055    echo
1056    echo "   Important! Continuing will delete all data from ${TARGET}!"
1057
1058    if [ -n "$FORCE" ] ; then
1059      einfo "Skip user acknowledgement as requested via --force option."
1060    else
1061      echo
1062      einfon "Is this ok for you? [y/N] "
1063      read -r a
1064      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1065         eerror "Exiting as requested." ; eend 1
1066         bailout 1
1067      fi
1068    fi
1069 fi
1070 }
1071 # }}}
1072
1073 # interactive mode {{{
1074 interactive_mode()
1075 {
1076   check4progs dialog || bailout 1
1077
1078   welcome_dialog
1079
1080   prompt_for_release
1081
1082   prompt_for_swraid
1083
1084   prompt_for_target
1085
1086   prompt_for_bootmanager
1087
1088   prompt_for_hostname
1089
1090   prompt_for_password
1091
1092   prompt_for_mirror
1093 }
1094
1095 # run interactive mode if we didn't get the according configuration yet
1096 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1097    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1098    INTERACTIVE=1
1099    interactive_mode
1100 fi
1101 # }}}
1102
1103 # architecture setup {{{
1104 if [ -n "$ARCH" ] ; then
1105    ARCHCMD="--arch $ARCH"
1106    ARCHINFO=" (${ARCH})"
1107 else
1108    ARCH="$(dpkg --print-architecture)"
1109    ARCHCMD="--arch $ARCH"
1110    ARCHINFO=" (${ARCH})"
1111 fi
1112 # }}}
1113
1114 # It is not possible to build amd64 on i686. {{{
1115 CURRENT_ARCH="$(uname -m)"
1116 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1117    if [ "$ARCH" = "amd64" ] ; then
1118       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
1119       bailout 1
1120    fi
1121 fi
1122 # }}}
1123
1124 # Support for generic release codenames is unavailable. {{{
1125 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1126    eerror "Generic release codenames (stable, testing) are unsupported. \
1127 Please use specific codenames such as lenny, squeeze, wheezy, jessie or stretch." ; eend 1
1128    bailout 1
1129 fi
1130 # }}}
1131
1132 checkconfiguration
1133
1134 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1135 if [ -n "$TARGET" ] ; then
1136    SHORT_TARGET="${TARGET##*/}"
1137 else
1138    eerror "Please adjust $CONFFILES/config or..."
1139    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
1140    bailout 1
1141 fi
1142 # }}}
1143
1144 # stages setup {{{
1145 if [ -z "$STAGES" ] ; then
1146    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1147    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1148 fi
1149
1150 if [ -r "$STAGES"/grml-debootstrap ] ; then
1151    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1152       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1153       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
1154    fi
1155 fi
1156 # }}}
1157
1158 # partition handling {{{
1159 PARTITION=''
1160 DIRECTORY=''
1161
1162 set_target_directory(){
1163     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1164     DIRECTORY=1
1165     MNTPOINT="$TARGET"
1166     MKFS=''
1167     TUNE2FS=''
1168     FSCK=''
1169     # make sure we normalise the path to an absolute directory name so something like:
1170     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1171     # works
1172     TARGET="$(readlink -f "$TARGET")"
1173 }
1174
1175 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1176     PARTITION=1
1177 else
1178     set_target_directory
1179 fi
1180 # }}}
1181
1182 # make sure we have the right syntax when using an iso image {{{
1183 if [ -n "$ISO" ] ; then
1184    case $ISO in
1185       file*) # do nothing
1186       ;;
1187       *)
1188       ISO=file:$ISO
1189       ;;
1190    esac
1191 fi
1192 ISODIR=${ISO##file:}
1193 ISODIR=${ISODIR%%/}
1194 # }}}
1195
1196 # Debian ISOs do not contain signed Release files {{{
1197 if [ -n "$ISO" ] ; then
1198     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1199 fi
1200 # }}}
1201
1202 # create filesystem {{{
1203 mkfs() {
1204   if [ -n "$DIRECTORY" ] ; then
1205      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1206      return 0
1207   fi
1208
1209   if grep -q "$TARGET" /proc/mounts ; then
1210     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
1211     bailout 1
1212   fi
1213
1214   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1215   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1216   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1217     case "$MKFS" in
1218       mkfs.ext*)
1219         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1220         MKFS_OPTS="$MKFS_OPTS -F"
1221         eend 0
1222
1223         ;;
1224     esac
1225   fi
1226
1227   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1228   # by default, which requires a recent version of tune2fs on the target system then,
1229   # so disable this feature for older Debian releases where it's known to be unsupported
1230   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1231     case "$RELEASE" in
1232       lenny|squeeze|wheezy|jessie)
1233         # assume a more recent version if we can't identify the version via dpkg-query
1234         local e2fsprogs_version
1235         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1236         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1237           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1238           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1239           eend 0
1240         fi
1241         ;;
1242     esac
1243   fi
1244
1245   if [ -n "$MKFS" ] ; then
1246     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1247     # shellcheck disable=SC2086
1248     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1249
1250     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1251       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1252         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1253         eend 1
1254         bailout 1
1255       else
1256         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1257         tune2fs "$TARGET" -U "$DISK_IDENTIFIER"
1258         eend $?
1259       fi
1260     fi
1261
1262     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1263     # will fail to detect the uuid in the chroot
1264     if [ -n "$VIRTUAL" ] ; then
1265       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1266     elif echo "$TARGET" | grep -q "/dev/md" ; then
1267       blockdev --rereadpt "${TARGET}"
1268     else
1269       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1270       local main_device="${TARGET%%[0-9]*}"
1271       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1272       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1273         blockdev --rereadpt "$main_device"
1274       else
1275         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1276       fi
1277     fi
1278     # give the system 2 seconds, otherwise we might run into
1279     # race conditions :-/
1280     sleep 2
1281
1282     eend $RC
1283   fi
1284 }
1285 # }}}
1286
1287 identify_target_uuid() {
1288   local device="$1"
1289
1290   if ! [ -b "$device" ] ; then
1291     return 1
1292   fi
1293
1294   eval "$(blkid -o udev "$1" 2>/dev/null)"
1295
1296   if [ -n "$ID_FS_UUID" ] ; then
1297     echo "$ID_FS_UUID"
1298   else
1299     return 1
1300   fi
1301 }
1302
1303 mountpoint_to_blockdevice() {
1304   TARGET_UUID=''
1305
1306   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1307   if [ -n "$TARGET_UUID" ] ; then
1308     einfo "Identified UUID $TARGET_UUID for $TARGET"
1309     return 0
1310   fi
1311
1312   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1313   for file in /sys/block/*/*/dev ; do
1314     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1315       local dev
1316       dev="${file%/dev}"
1317       dev="/dev/${dev##*/}"
1318       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1319
1320       if [ -n "$TARGET_UUID" ] ; then
1321         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1322         return 0
1323       fi
1324     fi
1325   done
1326 }
1327
1328 # modify filesystem settings {{{
1329 tunefs() {
1330   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1331      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1332      $TUNE2FS "$TARGET"
1333      eend $?
1334   fi
1335 }
1336 # }}}
1337
1338 # mount the new partition or if it's a directory do nothing at all {{{
1339 mount_target() {
1340   if [ -n "$DIRECTORY" ] ; then
1341      einfo "Running grml-debootstrap on a directory, nothing to mount."
1342   else
1343      if grep -q "$TARGET" /proc/mounts ; then
1344         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
1345      else
1346        if ! [ -d "${MNTPOINT}" ] ; then
1347           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1348        fi
1349        einfo "Mounting $TARGET to $MNTPOINT"
1350        mkdir -p "$MNTPOINT"
1351        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1352        eend $?
1353      fi
1354   fi
1355   if [ -n "$ISODIR" ] ; then
1356      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1357      mkdir -p "$MNTPOINT/$ISODIR"
1358      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1359      eend $?
1360   fi
1361 }
1362 # }}}
1363
1364 # prepare VM image for usage with debootstrap {{{
1365 prepare_vm() {
1366   if [ -z "$VIRTUAL" ] ; then
1367      return 0 # be quiet by intention
1368   fi
1369
1370   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1371      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1372      eend 1
1373      bailout 1
1374   fi
1375   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1376      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1377      eend 1
1378      bailout 1
1379   fi
1380
1381   ORIG_TARGET="$TARGET" # store for later reuse
1382
1383   if [ -n "$VMFILE" ]; then
1384     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1385   fi
1386   parted -s "${TARGET}" 'mklabel msdos'
1387   if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1388     einfo "Adjusting disk signature to a fixed (non-random) value"
1389     MBRTMPFILE=$(mktemp)
1390     dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1391     echo -en "\x41\x41\x41\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1392     dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1393     eend $?
1394   fi
1395   parted -s "${TARGET}" 'mkpart primary ext4 2M -1'
1396   parted -s "${TARGET}" 'set 1 boot on'
1397
1398   # if dm-mod isn't available then kpartx will fail with
1399   # "Is device-mapper driver missing from kernel? [...]"
1400   if ! kpartx -av "$TARGET" >/dev/null 2>&1 || ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1401     einfo "Device-mapper not ready yet, trying to load dm-mod module."
1402     modprobe dm-mod ; eend $?
1403   fi
1404
1405   # make sure loop module is present
1406   if ! losetup -f >/dev/null 2>&1; then
1407     einfo "Can not find a usable loop device, retrying after loading loop module."
1408     modprobe loop
1409     if losetup -f >/dev/null 2>&1; then
1410       einfo "Found a usable loop device now, continuing."
1411     else
1412       eerror "Error finding usable loop device" ; eend 1
1413       bailout 1
1414     fi
1415   fi
1416
1417   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3'
1418   if [ -z "${DEVINFO}" ] ; then
1419     eerror "Error setting up loopback device." ; eend 1
1420     bailout 1
1421   fi
1422
1423   # hopefully this always works as expected
1424   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1425   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1426   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
1427
1428   if [ -z "$TARGET" ] ; then
1429      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1430      bailout 1
1431   fi
1432 }
1433 # }}}
1434
1435 # make VM image bootable and unmount it {{{
1436 finalize_vm() {
1437   if [ -z "${VIRTUAL}" ] ; then
1438      return 0
1439   fi
1440
1441   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1442     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1443     bailout 1
1444   fi
1445
1446   mount -t proc none "${MNTPOINT}"/proc
1447   mount -t sysfs none "${MNTPOINT}"/sys
1448   mount -t devtmpfs udev "${MNTPOINT}"/dev
1449   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1450
1451 # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1452 # chroot-script skips installation for unset ${GRUB}
1453 if [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | fgrep -q GRUB; then
1454   einfo "Installing Grub as bootloader."
1455
1456   if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1457     echo "Notice: grub-pc package not present yet, installing it therefore."
1458     # shellcheck disable=SC2086
1459     DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y install $DPKG_OPTIONS grub-pc
1460   fi
1461
1462   mkdir -p "${MNTPOINT}/boot/grub"
1463   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1464      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1465      bailout 1
1466   fi
1467
1468   case "$RELEASE" in
1469     lenny|squeeze|wheezy)
1470       cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
1471       ;;
1472     *)
1473       cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1474       ;;
1475   esac
1476   dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1477   chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1478   dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1479   rm -f "${MNTPOINT}/tmp/core.img"
1480 fi
1481
1482   einfo "Updating grub configuration file."
1483   if [ -n "$BOOT_APPEND" ] ; then
1484      sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}"/etc/default/grub
1485   fi
1486   chroot "${MNTPOINT}" update-grub
1487
1488   case "$RELEASE" in
1489     jessie)
1490       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1491       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1492       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1493       ;;
1494   esac
1495
1496   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1497     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1498     ewarn "Please note that your system might NOT be able to properly boot."
1499   else
1500     einfo "Adjusting grub.cfg for successful boot sequence."
1501     sed -i "s;root=[^ ]\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1502   fi
1503
1504   umount "${MNTPOINT}"/proc
1505   umount "${MNTPOINT}"/sys
1506   umount "${MNTPOINT}"/dev/pts
1507   try_umount 3 "${MNTPOINT}"/dev
1508   umount "${MNTPOINT}"
1509   kpartx -d "${ORIG_TARGET}" >/dev/null
1510 }
1511 # }}}
1512
1513 # install main chroot {{{
1514 debootstrap_system() {
1515   if [ "$_opt_nodebootstrap" ]; then
1516      einfo "Skipping debootstrap as requested."
1517      return
1518   fi
1519
1520   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1521     :
1522   else
1523     eerror "Error: $MNTPOINT not mounted, can not continue."
1524     eend 1 ; exit 1
1525   fi
1526
1527   if [ -n "$ISO" ] ; then
1528     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1529     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1530     # shellcheck disable=SC2086
1531     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1532     RC=$?
1533   else
1534     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1535     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1536     # shellcheck disable=SC2086
1537     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1538     RC=$?
1539   fi
1540
1541   if [ $RC -ne 0 ] ; then
1542     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1543       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1544       einfo "Presenting last ten lines of debootstrap.log:"
1545       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1546       einfo "End of debootstrap.log"
1547     fi
1548   fi
1549
1550   eend $RC
1551 }
1552 # }}}
1553
1554 # prepare chroot via chroot-script {{{
1555 preparechroot() {
1556   einfo "Preparing chroot system"
1557
1558   # provide variables to chroot system
1559   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1560   touch "$CHROOT_VARIABLES"
1561   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1562   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1563   # Resorting to sed(1) for escaping since "VAR='${VAR//\'/\'\\\'\'}'" does not work with all versions of Bash,
1564   #   e.g. not with 4.2.37(1)-release (a.k.a 4.2+dfsg-0.1+deb7u3) of Debian wheezy
1565   [ -n "$ARCH" ]                && echo "ARCH='$(sed "s,','\\\\'',g" <<<"${ARCH}")'"                               >> "$CHROOT_VARIABLES"
1566   [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS='$(sed "s,','\\\\'',g" <<<"${BACKPORTREPOS}")'"             >> "$CHROOT_VARIABLES"
1567   [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${CHROOT_SCRIPTS}")'"           >> "$CHROOT_VARIABLES"
1568   [ -n "$COMPONENTS" ]          && echo "COMPONENTS='$(sed "s,','\\\\'',g" <<<"${COMPONENTS}")'"                   >> "$CHROOT_VARIABLES"
1569   [ -n "$CONFFILES" ]           && echo "CONFFILES='$(sed "s,','\\\\'',g" <<<"${CONFFILES}")'"                     >> "$CHROOT_VARIABLES"
1570   [ -n "$DEBCONF" ]             && echo "DEBCONF='$(sed "s,','\\\\'',g" <<<"${DEBCONF}")'"                         >> "$CHROOT_VARIABLES"
1571   [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND='$(sed "s,','\\\\'',g" <<<"${DEBIAN_FRONTEND}")'"         >> "$CHROOT_VARIABLES"
1572   [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP='$(sed "s,','\\\\'',g" <<<"${DEBOOTSTRAP}")'"                 >> "$CHROOT_VARIABLES"
1573   [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LOCALES}")'"         >> "$CHROOT_VARIABLES"
1574   [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LANGUAGE}")'"       >> "$CHROOT_VARIABLES"
1575   [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES='$(sed "s,','\\\\'',g" <<<"${EXTRAPACKAGES}")'"             >> "$CHROOT_VARIABLES"
1576   [ -n "$EFI" ]                 && echo "EFI='$(sed "s,','\\\\'',g" <<<"${EFI}")'"                                 >> "$CHROOT_VARIABLES"
1577   [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR='$(sed "s,','\\\\'',g" <<<"${FALLBACK_MIRROR}")'"         >> "$CHROOT_VARIABLES"
1578   [ -n "$FORCE" ]               && echo "FORCE='$(sed "s,','\\\\'',g" <<<"${FORCE}")'"                             >> "$CHROOT_VARIABLES"
1579   [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS='$(sed "s,','\\\\'',g" <<<"${GRMLREPOS}")'"                     >> "$CHROOT_VARIABLES"
1580   [ -n "$GRUB" ]                && echo "GRUB='$(sed "s,','\\\\'',g" <<<"${GRUB}")'"                               >> "$CHROOT_VARIABLES"
1581   [ -n "$HOSTNAME" ]            && echo "HOSTNAME='$(sed "s,','\\\\'',g" <<<"${HOSTNAME}")'"                       >> "$CHROOT_VARIABLES"
1582   [ -n "$INITRD" ]              && echo "INITRD='$(sed "s,','\\\\'',g" <<<"${INITRD}")'"                           >> "$CHROOT_VARIABLES"
1583   [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES='$(sed "s,','\\\\'',g" <<<"${INSTALL_NOTES}")'"             >> "$CHROOT_VARIABLES"
1584   [ -n "$ISODIR" ]              && echo "ISODIR='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                              >> "$CHROOT_VARIABLES"
1585   [ -n "$ISO" ]                 && echo "ISO='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                                 >> "$CHROOT_VARIABLES"
1586   [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST='$(sed "s,','\\\\'',g" <<<"${KEEP_SRC_LIST}")'"             >> "$CHROOT_VARIABLES"
1587   [ -n "$LOCALES" ]             && echo "LOCALES='$(sed "s,','\\\\'',g" <<<"${LOCALES}")'"                         >> "$CHROOT_VARIABLES"
1588   [ -n "$MIRROR" ]              && echo "MIRROR='$(sed "s,','\\\\'',g" <<<"${MIRROR}")'"                           >> "$CHROOT_VARIABLES"
1589   [ -n "$MKFS" ]                && echo "MKFS='$(sed "s,','\\\\'',g" <<<"${MKFS}")'"                               >> "$CHROOT_VARIABLES"
1590   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
1591   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
1592   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
1593   [ -n "$POST_SCRIPTS" ]        && echo "POST_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${POST_SCRIPTS}")'"               >> "$CHROOT_VARIABLES"
1594   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
1595   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
1596   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
1597   [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE='$(sed "s,','\\\\'',g" <<<"${RM_APTCACHE}")'"                 >> "$CHROOT_VARIABLES"
1598   [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD='$(sed "s,','\\\\'',g" <<<"${ROOTPASSWORD}")'"               >> "$CHROOT_VARIABLES"
1599   [ -n "$SCRIPTS" ]             && echo "SCRIPTS='$(sed "s,','\\\\'',g" <<<"${SCRIPTS}")'"                         >> "$CHROOT_VARIABLES"
1600   [ -n "$SECURE" ]              && echo "SECURE='$(sed "s,','\\\\'',g" <<<"${SECURE}")'"                           >> "$CHROOT_VARIABLES"
1601   [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS='$(sed "s,','\\\\'',g" <<<"${SELECTED_PARTITIONS}")'" >> "$CHROOT_VARIABLES"
1602   [ -n "$TARGET" ]              && echo "TARGET='$(sed "s,','\\\\'',g" <<<"${TARGET}")'"                           >> "$CHROOT_VARIABLES"
1603   [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM='$(sed "s,','\\\\'',g" <<<"${UPGRADE_SYSTEM}")'"           >> "$CHROOT_VARIABLES"
1604   [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID='$(sed "s,','\\\\'',g" <<<"${TARGET_UUID}")'"                 >> "$CHROOT_VARIABLES"
1605   [ -n "$TIMEZONE" ]            && echo "TIMEZONE='$(sed "s,','\\\\'',g" <<<"${TIMEZONE}")'"                       >> "$CHROOT_VARIABLES"
1606   [ -n "$TUNE2FS" ]             && echo "TUNE2FS='$(sed "s,','\\\\'',g" <<<"${TUNE2FS}")'"                         >> "$CHROOT_VARIABLES"
1607   [ -n "$VMSIZE" ]              && echo "VMSIZE='$(sed "s,','\\\\'',g" <<<"${VMSIZE}")'"                           >> "$CHROOT_VARIABLES"
1608
1609   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1610   chmod 755 "${MNTPOINT}"/bin/chroot-script
1611   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1612
1613   # make sure we have our files for later use via chroot-script
1614   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1615   # make sure we adjust the configuration variables accordingly:
1616   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1617   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1618   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1619
1620   # install notes:
1621   if [ -n "$INSTALL_NOTES" ] ; then
1622      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1623   fi
1624
1625   # package selection:
1626   if [ "$PACKAGES" = 'yes' ] ; then
1627     cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
1628       "${MNTPOINT}"/etc/debootstrap/packages
1629   fi
1630
1631   # debconf preseeding:
1632   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1633   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1634     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1635
1636   # copy scripts that should be executed inside the chroot:
1637   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1638   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1639     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1640     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1641   }
1642
1643   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1644   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1645
1646   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1647
1648   # make sure we can access network [relevant for cdebootstrap]
1649   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1650
1651   # setup default locales
1652   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1653
1654   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
1655   ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
1656
1657   # copy any existing files to chroot
1658   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1659   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1660   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1661   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1662   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1663   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1664   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1665
1666   # network setup
1667   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1668
1669 # Include files from /etc/network/interfaces.d when using
1670 # ifupdown v0.7.44 or newer:
1671 #source-directory /etc/network/interfaces.d
1672
1673 auto lo
1674 iface lo inet loopback
1675
1676 allow-hotplug eth0
1677 iface eth0 inet dhcp
1678 "
1679
1680   if [ -n "$NOINTERFACES" ] ; then
1681     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option" ; eend 0
1682   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1683     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1684     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1685     eend $?
1686   elif [ -n "$VIRTUAL" ] ; then
1687     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1688     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1689     eend $?
1690   elif [ -r /etc/network/interfaces ] ; then
1691     einfo "Copying /etc/network/interfaces from host to target system"
1692     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1693     eend $?
1694   else
1695     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1696     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1697     eend $?
1698   fi
1699
1700   # install config file providing some example entries
1701   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1702      cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1703   fi
1704
1705   eend 0
1706 }
1707 # }}}
1708
1709 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1710 execute_pre_scripts() {
1711   # make sure hostname is set even before chroot-script get executed
1712   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1713
1714   # make sure we have $MNTPOINT available for our scripts
1715   export MNTPOINT
1716
1717   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1718     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
1719     for script in "${pre_scripts}"/* ; do
1720       if [ -x "$script" ] ; then
1721         einfo "Executing pre-script $script"
1722         "$script" ; eend $?
1723       fi
1724     done
1725   fi
1726 }
1727 # }}}
1728
1729 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
1730 execute_post_scripts() {
1731   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
1732   export MNTPOINT
1733   export TARGET_HOSTNAME=$HOSTNAME
1734
1735   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
1736     # legacy support for /etc/debootstrap/scripts/
1737     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
1738     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
1739   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
1740     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
1741   fi
1742
1743   if [ -n "$post_scripts" ] ; then
1744     for script in "${post_scripts}"/* ; do
1745       if [ -x "$script" ] ; then
1746         einfo "Executing post-script $script"
1747         "$script" ; eend $?
1748       fi
1749     done
1750   fi
1751 }
1752 # }}}
1753
1754 try_umount() {
1755   local tries=$1
1756   local mountpoint="$2"
1757
1758   for (( try=1; try<=tries; try++ )); do
1759     if [[ ${try} -eq ${tries} ]]; then
1760       # Last time, show errors this time
1761       umount "${mountpoint}" && return 0
1762     else
1763       # Not last time, hide errors until fatal
1764       if umount "${mountpoint}" 2>/dev/null ; then
1765         return 0
1766       else
1767         sleep 1
1768       fi
1769     fi
1770   done
1771   return 1  # Tried enough
1772 }
1773
1774 # execute chroot-script {{{
1775 chrootscript() {
1776   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
1777     mount_target
1778   fi
1779
1780   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
1781     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
1782     eend 1
1783   else
1784     einfo "Executing chroot-script now"
1785     mount -t devtmpfs udev "${MNTPOINT}"/dev
1786     mount -t devpts devpts "${MNTPOINT}"/dev/pts
1787     if [ "$DEBUG" = "true" ] ; then
1788       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
1789     else
1790       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
1791     fi
1792     try_umount 3 "$MNTPOINT"/dev/pts
1793     try_umount 3 "$MNTPOINT"/dev
1794     eend $RC
1795   fi
1796
1797   # finally get rid of chroot-script again, there's no good reason to
1798   # keep it on the installed system
1799   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
1800     einfo "Removing chroot-script again"
1801     rm -f "${MNTPOINT}/bin/chroot-script"
1802     eend $?
1803   else
1804     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
1805     eend 0
1806   fi
1807 }
1808 # }}}
1809
1810 # unmount $MNTPOINT {{{
1811 umount_chroot() {
1812
1813   # display installation notes:
1814   if [ -n "$INSTALL_NOTES" ] ; then
1815      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
1816   fi
1817
1818   if [ -n "$ISODIR" ] ; then
1819      if grep -q "$ISODIR" /proc/mounts ; then
1820         einfo "Unmount $MNTPOINT/$ISODIR"
1821         umount "$MNTPOINT/$ISODIR"
1822         eend $?
1823      fi
1824   fi
1825
1826   if grep -q "$MNTPOINT" /proc/mounts ; then
1827      if [ -n "$PARTITION" ] ; then
1828         einfo "Unmount $MNTPOINT"
1829         umount "$MNTPOINT"
1830         eend $?
1831      fi
1832   fi
1833 }
1834 # }}}
1835
1836 # execute filesystem check {{{
1837 fscktool() {
1838  if [ -n "$VIRTUAL" ] ; then
1839    einfo "Skipping filesystem check because we deploy a virtual machine."
1840    return 0
1841  fi
1842
1843  if [ "$FSCK" = 'yes' ] ; then
1844    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
1845    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
1846    "$FSCKTOOL" "$TARGET"
1847    eend $?
1848  fi
1849 }
1850 # }}}
1851
1852 # get rid of grml-debootstrap config files {{{
1853 remove_configs() {
1854   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
1855     return 0
1856   fi
1857
1858   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
1859     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files." ; eend 0
1860     return 0
1861   fi
1862
1863   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
1864   rm -rf "${MNTPOINT}"/etc/debootstrap/
1865   eend $?
1866 }
1867 # }}}
1868
1869 # now execute all the functions {{{
1870 for i in format_efi_partition prepare_vm mkfs tunefs \
1871          mount_target mountpoint_to_blockdevice debootstrap_system \
1872          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
1873          remove_configs umount_chroot finalize_vm fscktool ; do
1874     if stage "${i}" ; then
1875       if "$i" ; then
1876         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
1877       else
1878         bailout 2 "$i"
1879       fi
1880     fi
1881 done
1882
1883 cleanup
1884 # }}}
1885
1886 # end dialog of autoinstallation {{{
1887 if [ -n "$AUTOINSTALL" ] ; then
1888    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
1889 Automatically rebooting in 10 seconds.
1890
1891 Choose Cancel to skip rebooting." 10 60 10 ; then
1892      noeject noprompt reboot
1893   fi
1894 else
1895    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
1896 fi
1897 # }}}
1898
1899 ## END OF FILE #################################################################
1900 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2